package ru.alphatech.icfpc.cards;

import ru.alphatech.icfpc.game.ICFPCException;
import ru.alphatech.icfpc.game.IValue;
import ru.alphatech.icfpc.game.Player;
import ru.alphatech.icfpc.game.Value;

public class Copy extends AbstractCard
{
	@Override
	public String getName() {
		return "copy";
	}
	
	@Override
	public IValue returnValue(IValue iobj, Player proponent, Player opponent)
	{
		incAndTest();
		
		if (iobj instanceof Value)
		{
			int i = ((Value)iobj).getValue();

			if (i >= 0 && i <= 255)
			{
				return opponent.getSlot(i).getValue();
			}
			else
			{
				throw new ICFPCException();
			}
		}
		else
		{
			throw new ICFPCException();
		}

	}
}
